--- old/usr/src/uts/common/fs/doorfs/door_sys.c	2015-08-09 12:47:37.897758733 +0300
+++ new/usr/src/uts/common/fs/doorfs/door_sys.c	2015-08-09 12:47:37.937995349 +0300
@@ -1784,6 +1784,11 @@
 	setf(fd, fp);
 	dp->d_data.d_desc.d_descriptor = fd;
 
+	/* add curproc to the pid list associated with that file */
+	if (fp->f_vnode != NULL)
+		(void) VOP_IOCTL(fp->f_vnode, F_FORKED, (intptr_t)curproc, FKIOCTL,
+			kcred, NULL, NULL);
+
 	/* Fill in the attributes */
 	if (VOP_REALVP(fp->f_vnode, &vp, NULL))
 		vp = fp->f_vnode;
